﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DataAccessTesting.Interfaces;

namespace DataAccessTesting.DataAccess
{
    public class PersonToDataSetAdapter
    {
        public void Adapt(IPerson fromValue, PersonDataSet.PersonRow toValue)
        {
            Adapt(fromValue, toValue, false);
        }

        public void Adapt(IPerson fromValue, PersonDataSet.PersonRow toValue, bool skipId)
        {
            if (fromValue == null)
                throw new ArgumentNullException("fromValue", "fromValue is null.");
            if (toValue == null)
                throw new ArgumentNullException("toValue", "toValue is null.");

            if (skipId == false)
            {
                toValue.Id = fromValue.Id;
            }

            toValue.FirstName = fromValue.FirstName;
            toValue.LastName = fromValue.LastName;
            toValue.EmailAddress = fromValue.EmailAddress;
        }

        public void Adapt<T>(DataAccessTesting.DataAccess.PersonDataSet.PersonDataTable fromValues, IList<IPerson> toValues)
            where T : IPerson, new()
        {
            if (fromValues == null)
                throw new ArgumentNullException("fromValues", "fromValues is null.");
            if (toValues == null)
                throw new ArgumentNullException("toValues", "toValues is null.");

            IPerson toValue;

            foreach (PersonDataSet.PersonRow fromValue in fromValues)
            {
                toValue = new T();

                Adapt(fromValue, toValue);

                toValues.Add(toValue);
            }
        }

        public void Adapt(PersonDataSet.PersonRow fromValue, IPerson toValue)
        {
            if (fromValue == null)
                throw new ArgumentNullException("fromValue", "fromValue is null.");
            if (toValue == null)
                throw new ArgumentNullException("toValue", "toValue is null.");

            toValue.Id = fromValue.Id;
            toValue.FirstName = fromValue.FirstName;
            toValue.LastName = fromValue.LastName;
            toValue.EmailAddress = fromValue.EmailAddress;
        }
    }
}
