﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Labs.Business.NorthwindDatasetTableAdapters;
using System.Data;

namespace Labs.Business
{
    public class CustomerSearchPresenter
    {
public void Initialize(ICustomerSearchView view)
{
    if (view == null)
    {
        throw new ArgumentNullException(
            "search", "Argument cannot be null.");
    }

    view.SearchValue = String.Empty;
    view.Results = null;
}

public void Search(ICustomerSearchView view)
{
    if (view == null)
    {
        throw new ArgumentNullException("search",
            "Argument cannot be null.");
    }

    if (String.IsNullOrEmpty(view.SearchValue) == true)
    {
        // empty result set
        view.Results =
            new NorthwindDataset.CustomersDataTable();
    }
    else
    {
        CustomersTableAdapter tableAdapter =
            new CustomersTableAdapter();

        view.Results =
            tableAdapter.GetDataByCustomerName(
            String.Format("%{0}%", view.SearchValue));
    }
}
    }
}
