﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Labs.Business;

namespace Labs.WebUI
{
    public partial class CustomerSearch :
        System.Web.UI.Page, ICustomerSearchView
    {
        private CustomerSearchPresenter m_Presenter =
            new CustomerSearchPresenter();

        protected void Page_Load(object sender, EventArgs e)
        {
            if (this.IsPostBack == false)
            {
                m_Presenter.Initialize(this);
            }
        }

        public string SearchValue
        {
            get
            {
                return m_SearchCompanyName.Text;
            }
            set
            {
                m_SearchCompanyName.Text = value;
            }
        }

        public NorthwindDataset.CustomersDataTable Results
        {
            get
            {
                return m_Grid.DataSource as NorthwindDataset.CustomersDataTable;
            }
            set
            {
                m_Grid.DataSource = value;
                m_Grid.DataBind();
            }
        }

        protected void m_BtnSearch_Click(object sender, EventArgs e)
        {
            m_Presenter.Search(this);
        }
    }
}



